public class Test {

    public static void main(String[] args) {
        Graph g = new Graph();

        // Build the graph
        try {
            g.addNode("0");
            g.addNode("1");
            g.addNode("2");
            g.addNode("3");
            g.addNode("4");
            g.addNode("5");
            g.addNode("6");
            g.addNode("7");
            g.addNode("8");
            g.addNode("9");
            g.addNode("a");
            g.addNode("b");
            g.addNode("c");
            g.addNode("d");
            g.addNode("e");
            g.addNode("f");
            g.addEdge("0","3");
            g.addEdge("0","8");
            g.addEdge("1","a");
            g.addEdge("2","b");
            g.addEdge("2","8");
            g.addEdge("3","c");
            g.addEdge("4","3");
            g.addEdge("4","0");
            g.addEdge("5","7");
            g.addEdge("5","b");
            g.addEdge("5","c");
            g.addEdge("5","e");
            g.addEdge("6","f");
            g.addEdge("7","2");
            g.addEdge("8","7");
            g.addEdge("8","5");
            g.addEdge("8","6");
            g.addEdge("9","0");
            g.addEdge("a","4");
            g.addEdge("a","d");
            g.addEdge("b","3");
            g.addEdge("b","2");
            g.addEdge("b","b");
            g.addEdge("c","e");
            g.addEdge("c","7");
            g.addEdge("d","e");
            g.addEdge("d","d");
            g.addEdge("d","1");
            g.addEdge("f","5");
            g.addEdge("f","4");
            System.out.println(g);
        } catch (DuplicateNodeException e) {
            System.err.println("Oops, I wanted to add a node twice\n"+e.getMessage());
            return;
        } catch (DuplicateEdgeException e) {
            System.err.println("Oops, I wanted to add an edge twice\n"+e.getMessage());
            return;
        } catch (GraphException e) {
            System.err.println("Some other Graph problem occured:\n"+e.getMessage());
            return;
        }

        // ask for two valid nodes until both are valid
        while (true) {
            try {
                System.out.print("Start-Node: ");
                String from = IO.readLine();
                System.out.print("Goal-Node: ");
                String to = IO.readLine();
                String path = g.findPath(from,to);
                if (path != null) {
                    System.out.println(path);
                } else {
                    System.out.println("There is no path");
                }
                return;
            } catch (NodeNotPresentException e) {
                System.err.println("One of your nodes was not present"+
                                   " in the graph\n"+e.getMessage());
            }
        }
    }

}
